#include <stdio.h>
#include <math.h>
int n;
double d[10];
int ord[10];
int flg[11];
int ordn;
double pi,u0;
double ncikl;
double rasst(double a, double b, double u)
{ 
  return sqrt(a*a+b*b-2.0*a*b*cos(u));
}
double ugol(double a, double b, double c)
{ return acos((a*a+b*b-c*c)/(2.0*a*b));
}
int rec(double u, int k, double u2)
{ double r,u1;
  int i,sav;
  if(u>=2.0*pi) return 0;
  if(k>3 && u>pi)
  {
    r=rasst((d[ord[0]]+d[ord[1]])/2.0,(d[ord[0]]+d[ord[k-1]])/2.0,2*pi-u);
    if(fabs(r-(d[ord[1]]+d[ord[k-1]])/2.0)<=0.005)
    { ordn=k;
      if(2*pi-u+u0<pi)
      { r=rasst((d[ord[0]]+d[ord[2]])/2.0,(d[ord[0]]+d[ord[k-1]])/2.0,2*pi-u+u0);
        if(r-(d[ord[2]]+d[ord[k-1]])/2.0<-1e-6)
          return 0;
      }
      return 1;
    }
    if(r<(d[ord[1]]+d[ord[k-1]])/2.0)
      return 0;
  }
  if(k>=n) return 0;
  i=-1;
  while(flg[i+1]>=0)
  {
    ++ncikl;
    sav=flg[i+1];
    flg[i+1]=flg[sav+1];
    ord[k]=sav;
    if(k<=1)
    { if(rec(0.0,k+1,0.0)) return 1;
    }
    else
    { 
      u1=ugol((d[ord[0]]+d[ord[k-1]])/2.0,
                    (d[ord[0]]+d[ord[k]])/2.0,
                    (d[ord[k]]+d[ord[k-1]])/2.0);
      if(k==2)
        u0=u1;
      if(k>2 && u1+u2<pi)
      {
        r=rasst((d[ord[0]]+d[ord[k]])/2.0,(d[ord[0]]+d[ord[k-2]])/2.0,u1+u2);
        if(r-(d[ord[k]]+d[ord[k-2]])/2.0>-1e-6)
          if(rec(u+u1,k+1,u1)) return 1;
      }
      else 
        if(rec(u+u1,k+1,u1)) return 1;
    }
    flg[i+1]=sav;
    i=sav;
  }
  return 0;
}
int main()
{
  FILE *f;
  int i;
  pi=M_PI; /* pi=acos(0)*2.0 */
  f=fopen("input.txt","r");
  fscanf(f,"%d",&n);
  for(i=0;i<n;i++)
    fscanf(f,"%lf",&d[i]);
  fclose(f);
  for(i=0;i<n;i++)
    flg[i]=i;
  flg[n]=-1;
  f=fopen("output.txt","w");
  if(rec(0.0,0,0.0))
  { for(i=0;i<ordn;i++)
      fprintf(f,"%d%c",ord[i]+1,(i<ordn-1)?' ':'\n');
  }  
  else
    fprintf(f,"IMPOSSIBLE\n");
  fclose(f);
  return 0;
}
